@echo off
REM Please feel free to redistribute this... although I'd like my name and details to stay in it please.
REM Originally created by Alasdair Clark
REM TechKit Limited 2019

:start
set name=
set options=
cls
echo.
echo.
echo CHKDSK A MOUNTED VOLUME WITHOUT A DRIVE LETTER
echo.
echo * By Alasdair Clark * www.techkit.co.uk * copyright 2019 *
echo.
echo.
echo First we need to find the mountpoint of the drive. This is done with mountvol
echo.
echo Read the output from mountvol from the bottom up, most of it is irrelevant 
echo.
GOTO admincheck

:admincheck
REM Using net service to check for administrator privileges
NET SESSION >nul 2>&1
IF %ERRORLEVEL% EQU 0 (
    PAUSE
    GOTO mountvol 
) ELSE (
    ECHO This command needs to be run with administrator privileges, right click on the icon and click "Run as Administrator"
    PAUSE
    EXIT
)

:mountvol
echo.
mountvol
echo Drive Serials look something like this \\?\Volume{c123456c-0000-0000-0000-000000000000}\
echo.
echo Using the mouse, highlight the drive serial that needs to be scanned, press enter, then ctrl+v to paste it here
echo You can just put a drive letter in here too if you want, if it exists
echo.
set /P name="Drive Serial: "
GOTO chkdsk1

:chkdsk1
echo.
echo Great, let's do an initial scan to see what's happening:
GOTO chkdsk

:chkdsk
echo.
chkdsk %options% %name%
echo.
CHOICE /C:YN /N /M "Read the message above. Do you need to do further scans on this drive? Y/N"
IF ERRORLEVEL 2 GOTO restart
IF ERRORLEVEL 1 GOTO options

:options
echo.
echo Read the above output and if errors are found chkdsk will tell you what operators to add.
set /P options="Please enter any options for chkdsk, e.g. /F /scan /spotfix etc. "
echo You have entered %options%
echo Now to run chkdsk again, with these options
GOTO chkdsk

:restart
echo.
CHOICE /C:YN /N /M "Great - do you want to scan another volume? Y/N"
IF ERRORLEVEL 2 GOTO end
IF ERRORLEVEL 1 GOTO start

:end
echo.
CHOICE /C:YN /N /M "Would you like to exit to a command prompt (rather than going back to windows)? Y/N"
IF ERRORLEVEL 2 GOTO exit
IF ERRORLEVEL 1 CMD

:exit
echo.
echo Operations complete. Press any key to exit.
pause
exit